SystemOrganization addCategory: #'GT-Metaceller-Glamour'!
SystemOrganization addCategory: #'GT-Metaceller-Model'!
SystemOrganization addCategory: #'GT-Metaceller-Tests'!

TestCase subclass: #GTMetacellerConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 10:55'!
testChildren
	| configuration |
	configuration := GTMetacellerConfiguration on: ConfigurationOfMetaceller.
	self assert: configuration children isEmpty! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 11:54'!
testMainProject
	| configuration |
	configuration := GTMetacellerConfiguration on: ConfigurationOfMetaceller.
	self deny: configuration mainProject hasAttributes! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 13:03'!
testProjects
	| configuration |
	configuration := GTMetacellerConfiguration on: ConfigurationOfMetaceller.
	self assert: configuration projects size equals: 3! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 10:57'!
testShortName
	| configuration |
	configuration := GTMetacellerConfiguration on: ConfigurationOfMetaceller.
	self assert: configuration shortName equals: 'Metaceller'! !

TestCase subclass: #GTMetacellerPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 14:10'!
testPlatformCommon
	| package |
	package := ((GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject version: '0.1') package: 'GT-Metaceller'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms contains: [ :each | each hasSymbol:#'common' ])! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 14:02'!
testPlatformGemstone
	| package |
	package := ((GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject version: '0.1') package: 'GlamourCore'.
	self assert: package isNil! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 14:09'!
testPlatformPharo
	| package |
	package := ((GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject version: '0.1') package: 'Glamour'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms includes: (GTPlatformDescription onSymbol: #'pharo'))! !

TestCase subclass: #GTMetacellerProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/17/2013 09:53'!
testCreateVersion
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject.
	self assert: (mainProject snapshotVersion: '0.2' baseline: '0.1-baseline') equals: 'version02: aSpec
	<version:''0.2'' imports: #( ''0.1-baseline'' )>

	aSpec for: #''gemstone'' do: [
		aSpec project: ''GlamourCore'' with: ''2.5-baseline''].
	aSpec for: #''common'' do: [
		aSpec package: ''GT-Metaceller'' with: ''GT-Metaceller-DiegoLont.25''].
	aSpec for: #''pharo'' do: [
		aSpec project: ''Glamour'' with: ''2.5-baseline''].
'! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/17/2013 09:31'!
testGemstone
	| project version |
	project := GTMetacellerAtributedProject on: ConfigurationOfMetaceller main: nil platform: (GTPlatformDescription onSymbol: #gemstone).
	version := project version: '0.1-baseline'.
	self assert: version packages size equals: 1.
	self assert: version projects size equals: 1! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 13:02'!
testProjects
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject.
	self assert: mainProject projects size equals: 3! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 13:07'!
testSymbols
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject.
	self assert: mainProject platformSymbols size equals: 3.
	self assert: (mainProject platformSymbols includes: #'common').
	self assert: (mainProject platformSymbols includes: #'gemstone').
	self assert: (mainProject platformSymbols includes: #'pharo').! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 13:09'!
testVersions
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: ConfigurationOfMetaceller) mainProject.
	self assert: mainProject versions size equals: 2.
	self assert: (mainProject versions contains: [ :each | each name  ='0.1-baseline' ]).
	self assert: (mainProject versions contains: [ :each | each name ='0.1' ])
! !

!MetacelloSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ #()! !

!MetacelloSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:14'!
labelAsText	
	^ self label! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller-model' stamp: 'TudorGirba 4/1/2013 09:16'!
hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: self name.
	^ g resolved first name ~= self currentVersionInfo name! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:11'!
labelAsText	
	^ self needsSaving
			ifTrue: [ Text string: self file attribute: TextColor blue] 
			ifFalse: [ Text fromString: self file ]! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller-model' stamp: 'TudorGirba 4/1/2013 09:07'!
needsSaving
	| copy |
	copy := self workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

MetacelloPlatform subclass: #GTMetacelloPlatform
	instanceVariableNames: 'originalPlatform platformDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription! !

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription: aGTPlatformDescription 
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription: aGTPlatformDescription ! !

!GTMetacelloPlatform class methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 14:50'!
initialize
	"
	GTMetacelloPlatform initialize
	"
	Current := self on: Current! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:52'!
new
	" this platform should always be created with a default platform "
	^self shouldNotImplement! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:51'!
on: aPlatform
	^self basicNew
		initialize: aPlatform;
		yourself! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName
	^self originalPlatform authorName! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName: aValue
	^self originalPlatform authorName: aValue! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories
	^self originalPlatform bypassGoferLoadUpdateCategories! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories: anObject
	^self originalPlatform bypassGoferLoadUpdateCategories: anObject! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassProgressBars
	^self originalPlatform bypassProgressBars! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:02'!
bypassProgressBars: anObject
	^self originalPlatform bypassProgressBars: anObject! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:02'!
clearCurrentVersionCache
	^self originalPlatform clearCurrentVersionCache! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:02'!
collection: aCollection do: aBlock displaying: aString
	^self originalPlatform collection: aCollection do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'user interaction' stamp: 'DiegoLont 9/16/2013 11:02'!
confirm: aString
	^self originalPlatform confirm: aString! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:03'!
copyClass: oldClass as: newName inCategory: newCategoryName
	^self originalPlatform copyClass: oldClass as: newName inCategory: newCategoryName! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:03'!
createRepository: aRepositorySpec
	^self originalPlatform createRepository: aRepositorySpec! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
defaultPlatformAttributes
	self platformDescription ifNil: [ ^self originalPlatform defaultPlatformAttributes ].
	^self platformDescription attributes! !

!GTMetacelloPlatform methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 11:04'!
defaultTimeout
	^self originalPlatform defaultTimeout! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:03'!
do: aBlock displaying: aString
	^self originalPlatform do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:04'!
extractTypeFromDescription: description

	^self originalPlatform extractTypeFromDescription: description
! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName

	^self originalPlatform globalNamed: globalName! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName ifAbsent: absentBlock

	^self originalPlatform globalNamed: globalName ifAbsent: absentBlock! !

!GTMetacelloPlatform methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 15:14'!
initialize: aPlatform
	self initialize.
	originalPlatform := aPlatform! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 15:18'!
originalPlatform
	^originalPlatform! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
platformDescription
	^platformDescription! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:51'!
platformDescription: aGTPlatformDescription 
	platformDescription := aGTPlatformDescription! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary
	^self originalPlatform primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheWith: aDictionary doing: noArgBlock
	^self originalPlatform primeStackCacheWith: aDictionary doing: noArgBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName at: key doing: aBlock
	^self originalPlatform stackCacheFor: cacheName at: key doing: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock

	^self originalPlatform stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock
! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:05'!
timestamp

	^self originalPlatform timestamp! !

!GTMetacelloPlatform methodsFor: 'transactions' stamp: 'DiegoLont 9/16/2013 11:05'!
transact: aBlock

	^self originalPlatform transact: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
useStackCacheDuring: aBlock defaultDictionary: defaultDictionary
	^self originalPlatform useStackCacheDuring: aBlock defaultDictionary: defaultDictionary! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 10:25'!
acceptCode: aText version: aVersion 
	aVersion methodClass compile: aText asString classified: aVersion methodCategory.
	self announce: GTConfigChanged! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:14'!
actionsForItem: anItem
	| retVal |
	retVal := OrderedCollection new.
 	retVal add: ((GLMGenericAction new) 
			action: [:list :version | self load: list selection fromVersion: version ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [:list | list selection inspect ];
			title: 'Inspect'
			yourself).
	(self isProject: anItem) ifTrue: [ retVal add: ((GLMGenericAction new) 
						action: [ :list | self fetchProject: list selection ];
						title: 'Load configuration'
						yourself) ].
	^retVal! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:19'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:18'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:04'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metaceller'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [  :r | r
				column: #configs;
				column: #versions;
				column: #packages span: 2 ];
		row: #details.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		from: #configs;
		to: #versions;
		andShow: [ :a | self versionBrowserOn: a ].
	browser transmit
		from: #configs;
		to: #details;
		andShow: [ :a | self detailsForConfiguration: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self detailsForVersion: a ].
	browser transmit
		from: #versions;
		to: #packages;
		andShow: [ :a | self packageBrowserOn: a ].
	browser transmit
		from: #packages;
		to: #details;
		andShow: [ :a | self detailsForPackage: a ].
	^ browser! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:09'!
childrenForItem: anItem
	anItem isString ifTrue: [ ^#() ].
	^anItem children! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/13/2013 10:08'!
configurationsIn: a
	^ a tree
		title: 'Configurations';
		format: [ :configuration | configuration shortName ];
		children: [ :configuration | configuration children ];
		updateOn: GTConfigLoaded from: self announcer;
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousRefresh on: $r entitled: 'Refresh' with: [ :pane | self announce: GTConfigLoaded ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection mainProject inspect ] entitled: 'Inspect'! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/13/2013 10:16'!
detailsForConfiguration: aBrowser
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Imports';
			painting: [:view :config | config viewVersionMapOn: view] ]
		ifFalse: [ 
			aBrowser text
				title: 'Imports';
				display: 'Please install roassal to see the imports' ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/10/2013 11:35'!
detailsForMethod: aBrowser
	aBrowser smalltalkCode
		smalltalkClass: [ :method | method methodClass ];
		display: [ :method | method asString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :method | self acceptCode: pane text method: method ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:00'!
detailsForPackage: aBrowser
	aBrowser text
		title: 'Package spec';
		display: [ :package | package asString ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:21'!
detailsForVersion: aBrowser
	aBrowser smalltalkCode
		title: 'Method';
		smalltalkClass: [ :version | version methodClass ];
		display: [ :version | version methodString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :version | self acceptCode: pane text version: version ].
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Dependencies';
			painting: [ :view :version | self viewDependenciesOf: version on: view ] ]
		ifFalse: [ 
			aBrowser text
				title: 'Dependencies';
				text: 'Please install roassal to view dependencies' ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 9/13/2013 09:44'!
entity 
	^ ((Object subclasses select: [:each | self isMetacelloConfig: each]) sort: [:a :b | a name < b name])
		collect: [ :each | GTMetacellerConfiguration on: each ]! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchProject: aProjectSpec
	" this seems more stable then the alternative:
			aProjectSpec resolveToLoadableSpec load.	
			that also fethces the versions we need.
	"
	aProjectSpec loadUsing: aProjectSpec loader gofer: nil.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchVersion: aVersion
	aVersion fetch.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:15'!
groupsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion groupsAndLoosePackages! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/26/2013 15:52'!
helpText
	^'Metaceller is a tool for browsing and editing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- bold = the stable version
- blue = the development version
- red  = the current bleeding edge
The tag shows the blessing of the configuration.

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = project
- bold = newer package in version than loaded in image
- underlined = package / project loaded in image
- italic = groups
- gray = older package in version than loaded in image
.'! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:08'!
isGroup: aSpec 
	^(aSpec isKindOf: MetacelloGroupSpec) or: [ aSpec isKindOf: GTMetacellerGroup ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/10/2013 14:05'!
isMetacelloConfig: anObject
	(anObject respondsTo: #isMetacelloConfig) ifTrue: [  
		(anObject className beginsWith: 'Metacello') ifFalse: [ ^anObject isMetacelloConfig ] ].
	^false! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:55'!
isPackage: aSpec 
	^(self isProject: aSpec) not and: [ (self isGroup: aSpec) not ]! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 15:32'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 13:12'!
itemsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion packagesAndProjects! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
load: aSpec fromVersion: aVersion
	aVersion load: aSpec name.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
loadVersion: aVersion
	aVersion load.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:05'!
nameForItem: anItem
	^anItem labelAsText! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:56'!
orderFor: anItemA and: anItemB 
	^anItemA label asLowercase < anItemB label asLowercase! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/12/2013 16:43'!
packageBrowserOn: aBrowser
	aBrowser tree
		title: 'Packages (load order)';
		display: [ :version | (self itemsForVersion: version) select: [ :each | each isGroup not ] ];
		children: [ :item | self childrenForItem: item ];
		format: [ :item | self nameForItem: item ];
		tags: [ :spec :version | self tagsOfSpec: spec in: version ];
		dynamicActionsOnSelection: [ :list | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer.
	aBrowser tree
		title: 'Groups';
		children: [ :item | self childrenForItem: item ];
		display: [ :version | self groupsForVersion: version ];
		updateOn: GTConfigChanged from: self announcer;
		format: [ :item | self nameForItem: item ].
	aBrowser tree
		title: 'Packages (alfabetical)';
		display: [ :version | (self itemsForVersion: version) asSortedCollection: [ :a :b | self orderFor: a and: b ] ];
		children: [ :item | (self childrenForItem: item) asSortedCollection: [ :a :b | self orderFor: a and: b ] ];
		format: [ :item | self nameForItem: item ];
		tags: [ :spec :version | self tagsOfSpec: spec in: version ];
		dynamicActionsOnSelection: [ :list | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer.
! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:36'!
tagsOfSpec: aSpec in: aVersion
	^aVersion tagsOf: aSpec! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:38'!
tagsOfVersion: aVersion
	^aVersion tags! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/8/2013 13:45'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/14/2013 16:50'!
versionBrowserOn: aBrowser
	aBrowser list
		title: 'Versions';
		display: [ :config | config mainVersions ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		tags: [ :version | version tags ];
		format: [ :version | version textLabel ].
	aBrowser list 
		title: 'Methods';
		display: [ :config | config mainMethods ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		format: [ :method | method selector ].
	aBrowser tree 
		title: 'Platforms';
		display: [ :config | config projects ];
		children: [ :project | project versions ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		tags: [ :version | version tags ];
		format: [ :version | version textLabel ].! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/9/2013 14:11'!
versionSourceFor: aVersion
	^aVersion asString! !

!GTMetaceller methodsFor: 'roassal' stamp: 'DiegoLont 4/12/2013 16:47'!
viewDependenciesOf: version on: view
	"| view |
	view := MOViewRenderer new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: 'default') on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires
			collect: [:each | all at: each ifAbsent: [ nil ] ] 
			thenSelect: [ :each | each notNil ] ].
	view horizontalDominanceTreeLayout layered! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ self projectReference version spec packages packageSpecsInLoadOrder! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:12'!
labelAsText	
	^ self name, ' ', self versionString! !

Announcement subclass: #GTConfigChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

GTConfigChanged subclass: #GTConfigLoaded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

Object subclass: #ConfigurationOfMetaceller
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!ConfigurationOfMetaceller commentStamp: '<historical>' prior: 0!
A ConfigurationOfGTMetaceller is a mock configuration as GTMetaceller is part of the GT Toolbox.

It has all kinds of strange constructs, to allow for testing.!

!ConfigurationOfMetaceller class methodsFor: 'development support' stamp: 'DiegoLont 9/13/2013 10:48'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMetaceller class methodsFor: 'metacello tool support' stamp: 'DiegoLont 9/13/2013 10:48'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMetaceller class methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
project

	^self new project! !

!ConfigurationOfMetaceller class methodsFor: 'development support' stamp: 'DiegoLont 9/13/2013 10:48'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMetaceller methodsFor: 'baselines' stamp: 'DiegoLont 9/16/2013 11:17'!
baseline01: aSpec
	<version: '0.1-baseline'>
	aSpec for: #common do: [ 
		aSpec blessing: #'baseline'.
		aSpec package: 'GT-Metaceller' ].
	
	aSpec for: #gemstone do: [ 
		aSpec project: 'GlamourCore' with: [
				aSpec
					className: 'ConfigurationOfGlamour';
					file: 'ConfigurationOfGlamour';
					version: #development;
					loads: #('Core');
					repository: 'http://www.smalltalkhub.com/mc/Moose/Glamour/main' ].
		aSpec package: 'GT-Metaceller' with: [ 
			aSpec requires: #( 'GlamourCore' ) ] ].

	aSpec for: #pharo do: [ 
		aSpec project: 'Glamour' with: [
				aSpec
					className: 'ConfigurationOfGlamour';
					file: 'ConfigurationOfGlamour';
					version: #development;
					loads: #('Extras' 'Morphic');
					repository: 'http://www.smalltalkhub.com/mc/Moose/Glamour/main' ].
		aSpec package: 'GT-Metaceller' with: [ 
			aSpec requires: #( 'Glamour' ) ] ]! !

!ConfigurationOfMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMetaceller methodsFor: 'versions' stamp: 'DiegoLont 9/16/2013 11:17'!
version01: aSpec
	<version: '0.1' imports: #( '0.1-baseline')>
	aSpec for: #'common' do: [ 
		aSpec blessing: #'development' ]! !

Object subclass: #GTMetacellerConfiguration
	instanceVariableNames: 'configuration mainProject projects platformSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerConfiguration class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2013 09:27'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:13'!
children
	^self mainProject childConfigurations collect: [ :each | GTMetacellerConfiguration on: each ]! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/13/2013 09:28'!
configuration
	^configuration! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/13/2013 10:07'!
displayString
	^self shortName! !

!GTMetacellerConfiguration methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2013 09:27'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:18'!
mainMethods
	^self mainProject allMethods ! !

!GTMetacellerConfiguration methodsFor: 'accessor' stamp: 'DiegoLont 9/16/2013 13:26'!
mainProject
	^mainProject ifNil: [ mainProject := GTMetacellerMainProject on: self configuration ]! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:17'!
mainVersions
	^self mainProject versions! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:05'!
projects
	^self mainProject projects! !

!GTMetacellerConfiguration methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 10:07'!
shortName
	^ ((self configuration name beginsWith: 'ConfigurationOf') 
		ifTrue: [self configuration name copyFrom: 'ConfigurationOf' size + 1 to: self configuration name size ] 
		ifFalse: [self configuration name]) asString! !

!GTMetacellerConfiguration methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	self mainProject viewVersionMapOn: view! !

Object subclass: #GTMetacellerItem
	instanceVariableNames: 'version referenceSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerItem subclass: #GTMetacellerGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:14'!
buildChildren
	| black gray |
	gray := (self version packagesForSpecNamed: self group name) asSet.
	black := OrderedCollection new.
	[ gray notEmpty ] whileTrue: [ 
		| spec |
		spec := gray anyOne.
		gray remove: spec.
		black add: spec.
		(self isPackage: spec) ifTrue: [ 
			spec requires do: [ :reqString |
				| package |
				package := self version packageNamed: reqString ifAbsent: [ nil ].
				package 
					ifNil: [ (self version packagesForSpecNamed: reqString) do: [ :each |
						(black includes: each) ifFalse: [ gray add: each ] ] ]
					ifNotNil: [ (black includes: package) ifFalse: [ gray add: package ] ] ].
			spec includes do: [ :inclString |
				| package |
				package := self version packageNamed: inclString ifAbsent: [ nil ].
				package 
					ifNil: [ (self version packagesForSpecNamed: inclString) do: [ :each |
						(black includes: each) ifFalse: [ gray add: each ] ] ]
					ifNotNil: [ (black includes: package) ifFalse: [ gray add: package ] ] ] ] ].
	^black! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 13:14'!
children
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:05'!
file
	^self group file! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
group
	^self referenceSpec! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^true! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:06'!
isPackageLoaded
	^self group isPackageLoaded! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:09'!
label
	^self group label! !

!GTMetacellerGroup methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:10'!
labelAsText
	^Text string: self label attribute: TextEmphasis italic! !

!GTMetacellerItem class methodsFor: 'instance creation' stamp: 'DiegoLont 4/24/2013 14:50'!
on: aVersion spec: aSpec
	^self basicNew
		initialize: aVersion spec: aSpec;
		yourself! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:53'!
asString
	^self referenceSpec asString ! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
children
	^#()! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:32'!
hasName: aString 
	^self name = aString! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:37'!
hasPlatform: aSymbol 
	^self platforms contains: [ :each | each hasSymbol: aSymbol ]! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:29'!
initialize: aVersion
	self initialize.
	version := aVersion! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/24/2013 14:49'!
initialize: aVersion spec: aSpec
	self initialize.
	version := aVersion.
	referenceSpec := aSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isPackage
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:37'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
labelAsText
	^self referenceSpec label! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
name
	^self referenceSpec name! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:46'!
platforms
	^self version platformsFor: self! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
referenceSpec
	^referenceSpec! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:30'!
version
	^version! !

!GTMetacellerItem methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:17'!
wrapperFor: aSpec version: aVersion
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: aVersion spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: aVersion spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: aVersion spec: aSpec ].
	^aSpec! !

GTMetacellerItem subclass: #GTMetacellerPackage
	instanceVariableNames: 'isNewer isOlder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
calculateIsNewer
	(self file = self referenceSpec name) ifTrue: [  ^false ].
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^false ] ].
	^true! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
calculateIsOlder
	(self file = self referenceSpec name) ifTrue: [  ^false ].	" no version specified "
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^true ] ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:10'!
file
	^self packageSpec file! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:23'!
isLoaded
	^self packageSpec isPackageLoaded! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isNewer
	^isNewer ifNil: [ isNewer := self calculateIsNewer ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isOlder
	^isOlder ifNil: [ isOlder := self calculateIsOlder ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isPackage
	^true! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 13:50'!
label
	^self file ifEmpty: [ self packageSpec name ]! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 13:49'!
labelAsText
	| prefix |
	prefix := ''.
	self needsSaving ifTrue: [ prefix := '* ' ].
	^(Text fromString: prefix), (Text string: self label attributes: self textAttributes)! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:44'!
loadedVersionName
	self referenceSpec workingCopy ifNotNil: [
		^self referenceSpec workingCopy ancestry ancestorString ].
	^self referenceSpec file! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:15'!
needsSaving
	self packageSpec workingCopy ifNotNilDo: [ :copy | ^copy needsSaving ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:09'!
packageSpec
	^self referenceSpec! !

!GTMetacellerPackage methodsFor: 'printing' stamp: 'DiegoLont 9/16/2013 14:40'!
printVersionOn: aStream 
	aStream nextPutAll: 'package: '''; nextPutAll: self name; nextPutAll: ''' with: '''; nextPutAll: self loadedVersionName; nextPutAll: ''''! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 4/25/2013 11:45'!
textAttributes
	| retVal |
	retVal := OrderedCollection new.
	self isLoaded ifTrue: [ 
		retVal add: TextEmphasis underlined.
		self isNewer ifTrue: [ retVal add: TextEmphasis bold ].
		self isOlder ifTrue: [  retVal add: TextColor gray ] ].
	^retVal! !

GTMetacellerItem subclass: #GTMetacellerProjectReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
children
	" here we return the 'labels' referenced by this project "
	| projectVersion |
	self isLoaded ifFalse: [ ^#() ].
	projectVersion := self projectReference versionOrNil.
	projectVersion ifNil: [  ^#() ].
	(self projectReference loads) ifNil: [ ^projectVersion spec packages packageSpecsInLoadOrder
		collect: [ :each | self wrapperFor: each version: projectVersion ] ].
	^self projectReference loads collect: [ :each | 
			self wrapperFor: (projectVersion packageNamed: each ifAbsent: [ each ]) version: projectVersion ]
	! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
configForProject
	| projectReference |
	projectReference := self projectReference.
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:58'!
file
	^self project file! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:55'!
isLoaded
	^self configForProject notNil! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^true! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:06'!
label
	^self project label! !

!GTMetacellerProjectReference methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:06'!
labelAsText
	| attributes |
	attributes := OrderedCollection new.
	(self isLoaded) ifTrue: [ attributes add: TextEmphasis underlined ].
	attributes add: TextColor blue.
	self versionString 
		ifNil: [ ^(Text string: self  label attributes: attributes), (Text string: ' No version' attribute: TextColor red) ]
		ifNotNil: [ ^(Text string: self label attributes: attributes), (Text string: (' ', self versionString) attribute: TextColor blue) ].
	! !

!GTMetacellerProjectReference methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 09:58'!
printVersionOn: aStream
	| configClass |
	configClass := Smalltalk at: self referenceSpec projectReference className asSymbol ifAbsent: [ nil ].
	aStream nextPutAll: 'project: '''; nextPutAll: self name; nextPutAll: ''' with: '.
	configClass
		ifNil: [ aStream nextPutAll: self referenceSpec projectReference versionString printString ]
		ifNotNil: [ aStream nextPut: $';
			nextPutAll: (configClass project version: self referenceSpec projectReference versionString) versionNumber printString;
			nextPut: $' ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:50'!
project
	^self referenceSpec! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:22'!
projectReference
	self project ifNil: [  ^nil ].
	(self project isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ ^self project projectReference ]
		ifFalse: [ ^self project ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:03'!
versionString
	^self project versionString! !

Object subclass: #GTMetacellerProject
	instanceVariableNames: 'configuration project stableVersion bleedingEdge development currentVersion versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerProject subclass: #GTMetacellerAtributedProject
	instanceVariableNames: 'platformDescription mainProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerAtributedProject class methodsFor: 'instance creation' stamp: 'DiegoLont 9/17/2013 09:30'!
on: aConfigurationClass main: aMainProject platform: aPlatformDescription
	^self basicNew
		initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription;
		yourself! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:23'!
displayString
	^self platformDescription symbol asString! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^true! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:25'!
hasPlatform: aPlatform
	^self platformDescription hasSymbol: aPlatform! !

!GTMetacellerAtributedProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription
	self initialize: aConfigurationClass.
	mainProject := aMainProject.
	platformDescription := aPlatformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:45'!
itemsFor: aPlatform in: aVersion 
	^(self version: aVersion name) items select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:30'!
mainProject
	^mainProject! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:44'!
platformDescription
	^ platformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:29'!
platformsFor: anItem version: aVersion 
	^self mainProject platformsFor: anItem version: aVersion! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:45'!
project
	^project ifNil: [ 
		GTMetacelloPlatform defaultPlatformDescription: self platformDescription.
		[ project := configuration project ] ensure: [ GTMetacelloPlatform defaultPlatformDescription: nil ] ]! !

GTMetacellerProject subclass: #GTMetacellerMainProject
	instanceVariableNames: 'platformSymbols projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:23'!
addPlatformSymbolsTo: aSet versionSpec: aSpec pragma: aPragma in: aConstructor
	aConstructor evaluatePragma: aPragma.
	aSet addAll: aConstructor attributeMap keys
! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
buildProjects
	^self platformSymbols collect: [ :each |
		GTMetacellerAtributedProject on: self configuration main: self platform: (GTPlatformDescription onSymbol: each) ]! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:23'!
createPlatformSymbols
	| retVal constructor versionMap symbolicVersionMap executionBlock |
	retVal := Set new.
	constructor := MetacelloVersionConstructor new
		configuration: self configuration new;
		yourself.
	versionMap := Dictionary new.
	symbolicVersionMap := Dictionary new.
	executionBlock := [ :versionSpec :pragma | self addPlatformSymbolsTo: retVal versionSpec: versionSpec pragma: pragma in: constructor ].
	constructor collectAllVersionsFromVersionPragmasInto: versionMap using: executionBlock.
	constructor
		collectAllVersionsFromVersionImportPragmasInto: versionMap
		using: executionBlock
		satisfiedPragmas: (constructor versionImportPragmasVerifiedDefinedIn: versionMap).
	constructor collectAllSymbolicVersionsFromVersionPragmasInto: symbolicVersionMap using: executionBlock.
	^retVal
! !

!GTMetacellerMainProject methodsFor: 'actions' stamp: 'DiegoLont 9/17/2013 09:48'!
createSnapshotVersion: aString baseline: aBaseline
	(self version: aString) ifNotNil: [ 
		" do not create a version that exists already, perhalps an error is more appropriate "
		^self ].
	self configuration compile: (self snapshotVersion: aString baseline: aBaseline)
		classified: 'snapshot-versions'! !

!GTMetacellerMainProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:21'!
hasPlatform: aPlatform
	(#common compare: aPlatform caseSensitive: false) = 2 ifTrue: [ ^true ].
	^MetacelloPlatform current defaultPlatformAttributes contains: [ :each |
		(each compare: aPlatform caseSensitive: false) = 2 ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:45'!
itemsFor: aPlatform in: aVersion 
	(self hasPlatform: aPlatform)
		ifTrue: [ ^(aVersion items
			select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]) ].
	^(self projectFor: aPlatform) itemsFor: aPlatform in: aVersion ! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:55'!
normalizePlatforms: aSet
	| retVal |
	retVal := Set new.
	aSet do: [ :newItem | 
		(aSet contains: [ :each | each isParent: newItem])
			ifFalse: [ retVal add: newItem ] ].
	^retVal! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:24'!
platformSymbols
	^platformSymbols ifNil: [ platformSymbols := self createPlatformSymbols ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:47'!
platformsFor: aMetacellerItem version: aVersionName
	| platforms |
	platforms := Set new.
	self projects do: [ :each |
		(each hasItem: aMetacellerItem inVersion: aVersionName) ifTrue: [ 
			platforms add: each platformDescription ] ].
	^self normalizePlatforms: platforms! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 09:58'!
printVersionsFor: aPlatform version: aVersion on: aStream
	| items |
	items := (self itemsFor: aPlatform in: aVersion).
	items ifNotEmpty: [ 
		| first |
		aStream tab; nextPutAll: 'aSpec for: '.
		aPlatform printOn: aStream.
		aStream nextPutAll: ' do: ['; cr.
		first := true.
		items do: [ :each |
			first 
				ifTrue: [ aStream tab; tab; nextPutAll: 'aSpec '.
					first := false ]
				ifFalse: [ aStream nextPut: $;; lf; tab; tab; tab ].
			each printVersionOn: aStream ].
		aStream nextPutAll: '].'; cr ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:24'!
projectFor: aPlatform
	^self projects detect: [ :each | each hasPlatform: aPlatform ]! !

!GTMetacellerMainProject methodsFor: 'dummy' stamp: 'DiegoLont 9/16/2013 13:25'!
projects
	^projects ifNil: [ projects := self buildProjects ]! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 09:20'!
snapshotVersion: aString baseline: aBaseline
	| version |
	" this method needs a baseline "
	version := self version: aBaseline.
	version ifNil: [ ^nil ].
	^String streamContents: [ :s |
		s nextPutAll: (('version', aString) asIdentifier: false); nextPutAll: ': aSpec'; cr;
			tab; nextPutAll: '<version:'''; nextPutAll: aString; nextPutAll: ''' imports: #( ''';nextPutAll: aBaseline; nextPutAll: ''' )>'; cr;
			cr.
		self platformSymbols do: [ :platform |
			self printVersionsFor: platform version: version on: s ] ]! !

!GTMetacellerProject class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:30'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 11:38'!
allMethods
	^GTMetacellerVersion allMethodsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:25'!
bleedingEdge
	bleedingEdge ifNil: [
		[ bleedingEdge := self project bleedingEdge ] on: MetacelloVersionDoesNotExistError ].
	^bleedingEdge! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:43'!
buildVersions
	^GTMetacellerVersion versionsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:24'!
checkCurrentVersion
	currentVersion ifNil: [ currentVersion := self project currentVersion ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:12'!
childConfigurations
	[ ^(self projectsForVersion: self project stableVersion) collect: [ :each | self configForProject: each ] thenSelect: [ :each | each notNil ] ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^#() ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:09'!
configForProject: aSpec
	| projectReference |
	aSpec ifNil: [  ^nil ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ projectReference := aSpec projectReference ]
		ifFalse: [ projectReference := aSpec ].
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
configuration
	^ configuration! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:22'!
currentVersion
	^ currentVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:26'!
development
	development ifNil: [ 
		[ development := self project development ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^development! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^false! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:49'!
hasItem: aMetacellerItem inVersion: aVersion
	^((self version: aVersion) ifNil: [ ^false ]) hasItem: aMetacellerItem! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:30'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/13/2013 10:11'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:19'!
metacelloVersion: aStringOrSymbol
	self project ifNil: [ ^nil ].
	^self project version: aStringOrSymbol! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
methodClass
	^self configuration! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
methodString
	^''! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
packages
	^#()! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
packagesAndProjects
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:33'!
project
	^project ifNil: [ project := configuration project ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:11'!
projectsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [ ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isProject: each ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/26/2013 16:26'!
stableVersion
	stableVersion ifNil: [ 
		[ stableVersion := self project stableVersion ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^stableVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
tags
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
textLabel
	^self displayString! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:13'!
version: aStringOrSymbol
	self project ifNil: [ ^nil ].
	^self versions detect: [ :each | each hasName: aStringOrSymbol ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:43'!
versions
	^versions ifNil: [ versions := GTMetacellerVersion versionsForProject: self ]! !

!GTMetacellerProject methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	| nodes edges |
	nodes := Dictionary new.
	edges := OrderedCollection new.
	(Pragma allNamed: #version: in: self configuration) do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)) ].
	(Pragma allNamed: #version:imports: in: self configuration) do: [:prag | 
		| version imported |
		version := nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [ project version: eachImportPrag ].
			edges add: version -> imported ] ].
	view shape label text: [ :each | each versionNumber printString ].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

Object subclass: #GTMetacellerVersion
	instanceVariableNames: 'method version configuration cachedPackageMap project groups items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 9/13/2013 11:39'!
allMethodsForProject:aProject
	^aProject configuration methods collect: [ :each |
		self on: aProject configuration method: each project: aProject ]! !

!GTMetacellerVersion class methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:27'!
isValidVersion: aVersion
	aVersion pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [  ^true ] ].
	^false! !

!GTMetacellerVersion class methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:07'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:03'!
on: aConfiguration method: aMethod project: aProject
	^self basicNew
		initialize: aConfiguration method: aMethod project: aProject;
		yourself! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 9/13/2013 11:40'!
versionsForProject: aProject
	^(aProject configuration methods
		select: [ :each | self isValidVersion: each ]
		thenCollect: [ :each | self on: aProject configuration method: each project: aProject ]) 
			asSortedCollection: [ :a :b | a name > b name ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:38'!
actions
	| retVal |
	retVal := OrderedCollection new.
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection inspect ];
			title: 'Inspect'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection method browse ];
			title: 'Browse method'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection load ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection fetch ];
			title: 'Fetch'
			yourself).
"
	This checks the current version, but it needs to update the ui without recreating the versions
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection checkCurrentVersion ];
			title: 'Check current version'
			yourself).
"	self isDevelopment ifTrue: [ 
	 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection update ];
			title: 'Update'
			yourself) ].
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:18'!
belongsToGroup: aSpec
	^(self tagsOf: aSpec) notEmpty! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 11:42'!
blessing
	^self version spec blessing value! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:12'!
buildGroups
	self version ifNotNil: [ 
		^self version groups collect: [ :each | GTMetacellerGroup on: self version spec: each ] ].
	^#()! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:31'!
buildItems
	^self packagesAndProjects collect: [ :each | self wrapperFor: each ] ! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:28'!
checkCurrentVersion
	self project checkCurrentVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration
	^ configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration: anObject
	configuration := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:15'!
determineVersion
	self project ifNil: [  ^nil ].
	self method pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [ ^self project metacelloVersion: (each arguments first) ] ].
	^nil! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:23'!
displayString
	^self textLabel! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:38'!
fetch
	self version ifNotNil: [ self version fetch ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 14:06'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 18:37'!
groupsAndLoosePackages
	^(OrderedCollection withAll: self packagesWithoutGroups)
		addAll: self groups;
		yourself! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:50'!
hasItem: aMetacellerItem
	^self items contains: [ :each | each name = aMetacellerItem name ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:13'!
hasName: aString 
	^self name = aString! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:05'!
initialize: aConfiguration method: aMethod project: aProject
	self initialize.
	method := aMethod.
	configuration := aConfiguration.
	project := aProject! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:16'!
isBleedingEdge
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^false
	"
	This should be this code ... but this is a bit slow
	[ ^(self project bleedingEdge = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ]."! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 11:44'!
isCurrent
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project currentVersion = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:50'!
isDevelopment
	^self blessing = #development! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:49'!
isDevelopmentVersion
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project development = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 13:14'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 16:10'!
isStable
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	[ ^(self project stableVersion = self version) ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^false ].! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:38'!
items
	^items ifNil: [ items := self buildItems ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:26'!
load
	self version ifNotNil: [ self version load ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 11:09'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method
	^ method! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method: anObject
	method := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:43'!
methodCategory
	^self method category! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodClass
	^self configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodString
	^self method asString! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 09:15'!
name
	method pragmas do: [  :each |
		(each key beginsWith: 'version') ifTrue: [ ^each arguments first ] ].
	^method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:30'!
package: aString
	^self items detect: [ :each | each hasName: aString ] ifNone: [ nil ]
	! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:40'!
packageNamed: aString ifAbsent: aBlock 
	self version ifNil: [ ^nil ].
	^self version packageNamed: aString ifAbsent: aBlock! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
packages
	self version ifNil: [ ^#() ].
	^self version packages! !

!GTMetacellerVersion methodsFor: 'caching' stamp: 'DiegoLont 4/22/2013 14:08'!
packagesAndGroups
	cachedPackageMap ifNil: [
		cachedPackageMap := Dictionary new.
		self version ifNotNil: [
			self groups do: [:eachGroup |
				eachGroup children do: [ :eachPackage |
					(cachedPackageMap at: eachPackage ifAbsentPut: [OrderedCollection new])
						add: eachGroup name ] ] ] ].
	^ cachedPackageMap! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:56'!
packagesAndProjects
	self version ifNil: [ ^#() ].
	^(self version spec packages packageSpecsInLoadOrder)
		collect: [ :each | self wrapperFor: each ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:47'!
packagesForSpecNamed: aVersionString 
	self version ifNotNil: [ ^self version packagesForSpecNamed: aVersionString ].
	^#()! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:22'!
packagesWithoutGroups
	" make sure the groups are built first "
	self groups.
	^self packagesAndProjects select: [ :each | (each isPackage or: [ each isProject ]) and: [ (self belongsToGroup: each) not ] ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:47'!
platformsFor: aMetacellerItem
	^self project platformsFor: aMetacellerItem version: self name! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:07'!
project
	^project! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
projects
	self version ifNil: [ ^#() ].
	^self version projects! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:38'!
selector
	^self method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
spec
	self version ifNotNil: [ ^self version spec ].
	^nil! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:43'!
tags
	self version ifNil: [  ^#() ].
	^Array with: self blessing! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 9/12/2013 16:10'!
tagsOf: aSpec
	(aSpec isKindOf: GTMetacellerItem) ifTrue: [ ^self tagsOf: aSpec referenceSpec ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [  ^self tagsOf: aSpec projectReference ].
	^self packagesAndGroups at: aSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerVersion methodsFor: 'display' stamp: 'DiegoLont 4/26/2013 15:50'!
textLabel
	| attributes |
	attributes := OrderedCollection new.
	self version ifNil: [ attributes add: TextColor red ].
	self isBleedingEdge ifTrue: [ attributes add: TextColor red  ].
	self isDevelopmentVersion ifTrue: [ attributes add: TextColor blue ].
	self isCurrent ifTrue: [ attributes add: TextEmphasis underlined ].
	self isStable ifTrue: [ attributes add: TextEmphasis bold ].
	^Text string: self name attributes: attributes! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 15:39'!
update
	self isDevelopment ifTrue: [
		MetacelloToolBox updateToLatestPackageVersionsIn: self configuration description: 'Please describe this version.' ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:18'!
version
	^ version ifNil: [ version := self determineVersion ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
version: anObject
	version := anObject! !

!GTMetacellerVersion methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:25'!
versions
	^#()! !

!GTMetacellerVersion methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:16'!
wrapperFor: aSpec
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: self spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: self spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: self spec: aSpec ].
	^aSpec
	! !

Object subclass: #GTPlatformDescription
	instanceVariableNames: 'symbol parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:54'!
allSymbols
	^self cached keys! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:54'!
buildOnSymbol: aSymbol
	| symbol |
	symbol := aSymbol asLowercase asSymbol.
	symbol = #'common' ifTrue: [ ^self on: nil symbol: symbol ].
	(#( #'gemstone' #'squeakcommon' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #common) symbol: symbol ].
	(#( #'pharo' #'squeak' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #squeakcommon) symbol: symbol ].
	(#( #'pharo1.x' #'pharo2.x' #'pharo3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #pharo) symbol: symbol ].
	(#( #'pharo1.0.x' #'pharo1.1.x' #'pharo1.2.x' #'pharo1.3.x' #'pharo1.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'pharo1.x') symbol: symbol ].
	(#( #'gs2.x' #'gs3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gemstone') symbol: symbol ].
	(#( #'gs2.3.x' #'gs2.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs2.x') symbol: symbol ].
	(#( #'gs3.0.x' #'gs3.1.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs3.x') symbol: symbol ].
	" if this is reached, we need to specify more symbols in the hierarchie "
	^self on: nil symbol: aSymbol! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
cached
	^cached ifNil: [ cached := Dictionary new ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 11:35'!
on: aParent symbol: aSymbol
	^self basicNew
		initialize: aParent symbol: aSymbol;
		yourself! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
onSymbol: aSymbol
	| symbol |
	symbol := aSymbol asLowercase asSymbol.
	^self cached at: symbol ifAbsentPut: [ self buildOnSymbol: symbol ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
resetCache
	cached := nil! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributes
	^self attributesWith: OrderedCollection new! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributesWith: aCollection
	self parent ifNotNil: [ self parent attributesWith: aCollection ].
	^aCollection
		add: self symbol;
		yourself! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:26'!
hasSymbol: aSymbol
	^(symbol compare: aSymbol caseSensitive: false) = 2! !

!GTPlatformDescription methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 11:36'!
initialize: aParent symbol: aSymbol
	self initialize.
	parent := aParent.
	symbol := aSymbol! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:07'!
isParent: aPlatformDescription 
	aPlatformDescription ifNil: [ ^false ].
	aPlatformDescription parent = self ifTrue: [ ^true ].
	^self isParent: aPlatformDescription parent! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
parent
	^ parent! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:58'!
printOn: aStream
	self symbol printOn: aStream! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
symbol
	^ symbol! !
GTMetacelloPlatform initialize!
